﻿Imports Microsoft.VisualBasic
Imports System
Imports System.Linq
Imports System.Collections.Generic

Imports NorthwindCacheDemo.DTO
Imports NorthwindCacheDemo.CL
Imports NorthwindCacheDemo.DAL

Namespace NorthwindCacheDemo.BLL
	''' <summary>
	''' Provides business logic over the Northwind product catalog.
	''' The CatalogService class provides method that validate input,
	''' and retrieve transfer objects representing the product catalog.
	''' These methods will first validate input, then call to the underlying
	''' read-through cache layer to provide the caller with the requested
	''' product catalog transfer objects.
	''' </summary>
	Public Class CatalogService
		Public Sub New()
		End Sub

		Public Function GetCategories() As IList(Of Category)
			Return CacheLayer.CatalogCache.GetCategories()
		End Function

		Public Function GetCategory(ByVal id As Integer) As Category
			If id <= 0 Then
				Return Nothing
			End If

			Return CacheLayer.CatalogCache.GetCategory(id)
		End Function

		Public Function GetProduct(ByVal id As Integer) As Product
			If id <= 0 Then
				Return Nothing
			End If

			Return CacheLayer.CatalogCache.GetProduct(id)
		End Function

		Public Function GetProductsByCategory(ByVal id As Integer) As IList(Of Product)
			If id <= 0 Then
				Return Nothing
			End If

			Return CacheLayer.CatalogCache.GetProductsByCategory(id)
		End Function

		Public Function GetPopularProducts() As IList(Of Product)
			Return CacheLayer.CatalogCache.GetPopularProducts()
		End Function

		Public Function GetPopularProductsByCategory(ByVal id As Integer) As IList(Of Product)
			If id <= 0 Then
				Return Nothing
			End If

			Return CacheLayer.CatalogCache.GetPopularProductsByCategory(id)
		End Function

		Public Function GetAlsoPurchasedProducts(ByVal id As Integer) As IList(Of Product)
			If id <= 0 Then
				Return Nothing
			End If

			Return CacheLayer.CatalogCache.GetAlsoPurchasedProducts(id)
		End Function
	End Class
End Namespace
