﻿Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports System.Transactions

Imports NorthwindCacheDemo.DTO
Imports NorthwindCacheDemo.DAL

Namespace NorthwindCacheDemo.BLL
	''' <summary>
	''' Provides business logic over the Northwind order subject area.
	''' The ProcessOrder method within this class wraps calls to the
	''' data layer in a TransactionScope to robustly persist Order and
	''' OrderItems to the underlying data store.
	''' </summary>
	Public Class OrderService
		Public Sub ProcessOrder(ByVal cart As ShoppingCart, ByVal name As String, ByVal address As String, ByVal city As String, ByVal region As String, ByVal postalCode As String, ByVal country As String)
			Using scope As New TransactionScope()
				Dim order As New Order() With {.OrderDate = DateTime.Now, .ShipName = name, .ShipAddress = address, .ShipCity = city, .ShipRegion = region, .ShipPostalCode = postalCode, .ShipCountry = country}

				Dim orderID As Integer = DataLayer.OrderProvider.InsertOrder(order)

				Dim orderItem As OrderItem = Nothing
				For Each cartItem As ShoppingCartItem In cart
					orderItem = New OrderItem() With {.OrderID = orderID, .ProductID = cartItem.ProductID, .Quantity = cartItem.Quantity, .UnitPrice = cartItem.UnitPrice}

					DataLayer.OrderProvider.InsertOrderItem(orderItem)
				Next cartItem

				scope.Complete()
			End Using
		End Sub
	End Class
End Namespace
