﻿Imports Microsoft.VisualBasic
Imports System
Imports System.Data
Imports System.Data.SqlClient

Imports NorthwindCacheDemo.DTO

Namespace NorthwindCacheDemo.DAL.SqlClient
	''' <summary>
	''' Provides data access to the Northwind order subject area.
	''' The methods in this class use System.Data.SqlClient to 
	''' create records in the Orders and Order Details tables.
	''' Typically, the caller wraps calls to these methods in
	''' a TransactionScope.
	''' </summary>
	Public Class SqlOrderProvider
		Inherits SqlProvider
		Implements IOrderProvider
		Public Sub New()
		End Sub

		Public Function InsertOrder(ByVal order As Order) As Integer Implements IOrderProvider.InsertOrder
			Dim commandText As String = String.Format("INSERT INTO [Northwind].[dbo].[Orders] " & ControlChars.CrLf & "                (OrderDate, ShipName, ShipAddress, ShipCity, ShipRegion, ShipPostalCode, ShipCountry) " & ControlChars.CrLf & "                VALUES ('{0}', '{1}', '{2}', '{3}', '{4}', '{5}', '{6}')" & ControlChars.CrLf & "                SELECT @@IDENTITY", order.OrderDate, order.ShipName, order.ShipAddress, order.ShipCity, order.ShipRegion, order.ShipPostalCode, order.ShipCountry)

			Dim orderID As Integer = 0
			Using conn As New SqlConnection(Me.ConnectionString)
				Dim cmd As New SqlCommand(commandText, conn)
				cmd.CommandType = CommandType.Text
				conn.Open()

				orderID = Convert.ToInt32(cmd.ExecuteScalar())
			End Using

			Return orderID
		End Function

		Public Sub InsertOrderItem(ByVal orderItem As OrderItem) Implements IOrderProvider.InsertOrderItem
			Dim commandText As String = String.Format("INSERT INTO [Northwind].[dbo].[Order Details] " & ControlChars.CrLf & "                    (OrderID, ProductID, UnitPrice, Quantity) " & ControlChars.CrLf & "                    VALUES ({0}, {1}, {2}, {3})", orderItem.OrderID, orderItem.ProductID, orderItem.UnitPrice, orderItem.Quantity)

			Using conn As New SqlConnection(Me.ConnectionString)
				Dim cmd As New SqlCommand(commandText, conn)
				cmd.CommandType = CommandType.Text
				conn.Open()

				cmd.ExecuteNonQuery()
			End Using
		End Sub
	End Class
End Namespace
