﻿Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Specialized
Imports System.Configuration

Namespace NorthwindCacheDemo.DAL
	Public NotInheritable Class DataLayer
		Private Shared _catalogProvider As ICatalogProvider

		Private Shared _orderProvider As IOrderProvider

		Private Sub New()
		End Sub
		Shared Sub New()
			Dim config As NameValueCollection = CType(ConfigurationManager.GetSection("northwindCacheDemo"), NameValueCollection)

			Dim t As Type = Type.GetType(config("CatalogProvider"))
			_catalogProvider = CType(Activator.CreateInstance(t), ICatalogProvider)

			t = Type.GetType(config("OrderProvider"))
			_orderProvider = CType(Activator.CreateInstance(t), IOrderProvider)
		End Sub

		Public Shared ReadOnly Property CatalogProvider() As ICatalogProvider
			Get
				Return _catalogProvider
			End Get
		End Property

		Public Shared ReadOnly Property OrderProvider() As IOrderProvider
			Get
				Return _orderProvider
			End Get
		End Property
	End Class
End Namespace
