﻿Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic

Namespace NorthwindCacheDemo.DTO
	<Serializable> _
	Public Class ShoppingCart
		Implements IEnumerable(Of ShoppingCartItem)
		Private _items As IDictionary(Of Integer, ShoppingCartItem)

		Public Sub New()
			_items = New Dictionary(Of Integer, ShoppingCartItem)()
		End Sub

		Default Public Property Item(ByVal productID As Integer) As ShoppingCartItem
			Get
                Dim cartItem As ShoppingCartItem = Nothing

                If _items.TryGetValue(productID, cartItem) Then
                    Return cartItem
                End If

				Return Nothing
			End Get
			Set(ByVal value As ShoppingCartItem)
				If value Is Nothing Then
					_items.Remove(productID)
				Else
					_items(productID) = value
				End If
			End Set
		End Property

		Public ReadOnly Property IsEmpty() As Boolean
			Get
				Return (_items.Count = 0)
			End Get
		End Property

		Public ReadOnly Property Total() As Decimal
			Get
                Dim cartTotal As Decimal = 0
				For Each item As ShoppingCartItem In _items.Values
					cartTotal += (item.UnitPrice * item.Quantity)
				Next item
				Return cartTotal
			End Get
		End Property

		Public Function GetEnumerator() As IEnumerator(Of ShoppingCartItem) Implements IEnumerable(Of ShoppingCartItem).GetEnumerator
            Return _items.Values.GetEnumerator()
        End Function

		Private Function IEnumerable_GetEnumerator() As System.Collections.IEnumerator Implements System.Collections.IEnumerable.GetEnumerator
            Return _items.Values.GetEnumerator()
        End Function
	End Class
End Namespace
