﻿Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Web
Imports System.Web.UI
Imports System.Web.UI.WebControls

Imports NorthwindCacheDemo.DTO
Imports NorthwindCacheDemo.BLL

Partial Public Class Cart
	Inherits System.Web.UI.Page
	Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs)
		If (Not IsPostBack) Then
			Dim cart As ShoppingCart = CType(Session("ShoppingCart"), ShoppingCart)

			RenderView(cart)
		End If
	End Sub

	Private Sub RenderView(ByVal cart As ShoppingCart)
		If cart Is Nothing OrElse cart.IsEmpty Then
			' show no cart message
			ShoppingPanel.Visible = False
			Message.Visible = True
		Else
			ShoppingPanel.Visible = True
			Message.Visible = False

			CartGridView.DataSource = cart
			CartGridView.DataBind()
			TotalLabel.Text = String.Format("{0:c}", cart.Total)
		End If
	End Sub

	Protected Sub UpdateCartButton_Click(ByVal sender As Object, ByVal e As EventArgs)
		Dim cart As ShoppingCart = CType(Session("ShoppingCart"), ShoppingCart)
		UpdateCart(cart)
		RenderView(cart)
	End Sub

	Private Sub UpdateCart(ByVal cart As ShoppingCart)
		For Each r As GridViewRow In CartGridView.Rows
			Dim productIDLabel As Label = CType(r.FindControl("ProductIDLabel"), Label)
			Dim productID As Integer = Convert.ToInt32(productIDLabel.Text)

			Dim remove As CheckBox = CType(r.FindControl("RemoveCheckBox"), CheckBox)
			Dim quantityTextBox As TextBox = CType(r.FindControl("QuantityTextBox"), TextBox)
			Dim quantity As Integer = Convert.ToInt32(quantityTextBox.Text)
			If remove.Checked OrElse quantity <= 0 Then
				cart(productID) = Nothing
				Continue For
			End If

			cart(productID).Quantity = quantity
		Next r
	End Sub

	Protected Sub CartGridView_RowDataBound(ByVal sender As Object, ByVal e As GridViewRowEventArgs)
		If e.Row.RowType <> DataControlRowType.DataRow Then
			Return
		End If

		Dim cartItem As ShoppingCartItem = CType(e.Row.DataItem, ShoppingCartItem)

		Dim p As Product = ServiceLayer.CatalogService.GetProduct(cartItem.ProductID)

		Dim productIDLabel As Label = CType(e.Row.FindControl("ProductIDLabel"), Label)
		Dim productLink As HyperLink = CType(e.Row.FindControl("ProductLink"), HyperLink)
		Dim unitPriceLabel As Label = CType(e.Row.FindControl("UnitPriceLabel"), Label)
		Dim quantityTextBox As TextBox = CType(e.Row.FindControl("QuantityTextBox"), TextBox)

		productIDLabel.Text = cartItem.ProductID.ToString()
		productLink.Text = p.Name
		productLink.NavigateUrl = String.Format("~/Product.aspx?id={0}", cartItem.ProductID)
		unitPriceLabel.Text = String.Format("{0:c}", cartItem.UnitPrice)
		quantityTextBox.Text = cartItem.Quantity.ToString()
	End Sub

	Protected Sub CheckoutButton_Click(ByVal sender As Object, ByVal e As EventArgs)
		Dim cart As ShoppingCart = CType(Session("ShoppingCart"), ShoppingCart)
		UpdateCart(cart)

		If cart.IsEmpty Then
			RenderView(cart)
		Else
			Response.Redirect("~/Purchase.aspx")
		End If
	End Sub
End Class
