﻿Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Web
Imports System.Web.UI
Imports System.Web.UI.WebControls

Imports NorthwindCacheDemo.DTO
Imports NorthwindCacheDemo.BLL

Partial Public Class _Product
	Inherits System.Web.UI.Page
	Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs)
		If (Not IsPostBack) Then
			Dim id As Integer = Convert.ToInt32(Request.Params("id"))

			Dim p As Product = ServiceLayer.CatalogService.GetProduct(id)
			Dim c As Category = ServiceLayer.CatalogService.GetCategory(p.CategoryID)
			Dim products As IList(Of Product) = ServiceLayer.CatalogService.GetAlsoPurchasedProducts(id)

			RenderView(p, c, products)
		End If
	End Sub

	Private Sub RenderView(ByVal p As Product, ByVal c As Category, ByVal products As IList(Of Product))
		ProductTitleLabel.Text = p.Name
		ProductImage.ImageUrl = String.Format("~/images/{0}.jpg", p.CategoryID)

		ProductNameLabel.Text = p.Name
		QuantityPerUnitLabel.Text = p.QuantityPerUnit
		UnitPriceLabel.Text = String.Format("{0:c}", p.UnitPrice)

		CategoryLink.NavigateUrl = String.Format("~/Catalog.aspx?id={0}", c.CategoryID)
		CategoryLink.Text = c.Name

		ProductGridView.DataSource = products
		ProductGridView.DataBind()
	End Sub

	Protected Sub AddToCartButton_Click(ByVal sender As Object, ByVal e As EventArgs)
		Dim cart As ShoppingCart = CType(Session("ShoppingCart"), ShoppingCart)

		If cart Is Nothing Then
			cart = New ShoppingCart()
			Session("ShoppingCart") = cart
		End If

		Dim productID As Integer = Convert.ToInt32(Request.Params("id"))

		Dim item As ShoppingCartItem = cart(productID)
		If item IsNot Nothing Then
			item.Quantity += 1
		Else
			Dim p As Product = ServiceLayer.CatalogService.GetProduct(productID)

			cart(productID) = New ShoppingCartItem() With {.ProductID = productID, .Quantity = 1, .UnitPrice = p.UnitPrice}
		End If

		Response.Redirect("~/Cart.aspx")
	End Sub
End Class
