﻿Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Web
Imports System.Web.UI
Imports System.Web.UI.WebControls

Imports NorthwindCacheDemo.DTO
Imports NorthwindCacheDemo.BLL

Partial Public Class Purchase
	Inherits System.Web.UI.Page
	Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs)
		If (Not IsPostBack) Then
			Dim cart As ShoppingCart = CType(Session("ShoppingCart"), ShoppingCart)
			CartGridView.DataSource = cart
			CartGridView.DataBind()

			TotalLabel.Text = String.Format("{0:c}", cart.Total)
		End If
	End Sub

	Protected Sub CartGridView_RowDataBound(ByVal sender As Object, ByVal e As GridViewRowEventArgs)
		If e.Row.RowType <> DataControlRowType.DataRow Then
			Return
		End If

		Dim cartItem As ShoppingCartItem = CType(e.Row.DataItem, ShoppingCartItem)
		Dim p As Product = ServiceLayer.CatalogService.GetProduct(cartItem.ProductID)

		Dim nameLabel As Label = CType(e.Row.FindControl("NameLabel"), Label)
		Dim unitPriceLabel As Label = CType(e.Row.FindControl("UnitPriceLabel"), Label)
		Dim quantityLabel As Label = CType(e.Row.FindControl("QuantityLabel"), Label)

		nameLabel.Text = p.Name
		unitPriceLabel.Text = String.Format("{0:c}", cartItem.UnitPrice)
		quantityLabel.Text = cartItem.Quantity.ToString()
	End Sub

	Protected Sub CheckoutButton_Click(ByVal sender As Object, ByVal e As EventArgs)
		Dim cart As ShoppingCart = CType(Session("ShoppingCart"), ShoppingCart)

		ServiceLayer.OrderService.ProcessOrder(cart, NameTextBox.Text, AddressTextBox.Text, CityTextBox.Text, RegionTextBox.Text, PostalCodeTextBox.Text, CountryTextBox.Text)

		Session("ShoppingCart") = Nothing

		Response.Redirect("~/Congrats.aspx")
	End Sub
End Class
