﻿Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.Data.Caching

Imports NorthwindCacheDemo.DTO

Namespace VelocityClientConsole
	Friend Class CatalogRegionSample
		Shared Sub Main(ByVal args() As String)
			' Create the catalog cache object
			Dim factory As New CacheFactory()
			Dim catalogCache As Cache = factory.GetCache("catalog")

			' Create a category region with eviction disabled
			catalogCache.CreateRegion("BeveragesRegion", False)
			catalogCache.CreateRegion("ProduceRegion", False)

			' Build catalog
			catalogCache.Put("Category-1", New Category() With {.Name = "Beverages"})
			catalogCache.Put("Category-7", New Category() With {.Name = "Produce"})
			catalogCache.Put("BeveragesRegion", "Product-1", New Product() With {.Name = "Chai"})
			catalogCache.Put("BeveragesRegion", "Product-43", New Product() With {.Name = "Coffee"})
			catalogCache.Put("ProduceRegion", "Product-7", New Product() With {.Name = "Pears"})
			catalogCache.Put("ProduceRegion", "Product-51", New Product() With {.Name = "Apples"})

			' Retrieve the products in the Category-1 region
			Dim enumerator As IEnumerator(Of KeyValuePair(Of String, Object)) = catalogCache.GetEnumerator("BeveragesRegion")

			Dim p As Product = Nothing
			Do While enumerator.MoveNext()
				p = CType(enumerator.Current.Value, Product)
				Console.WriteLine(p.Name)
			Loop

			' Retrieve an individual product in the ProduceRegion
			p = CType(catalogCache.Get("ProduceRegion", "Product-51"), Product)

			Console.WriteLine(p.Name)

			catalogCache.Remove("Category-1")
			catalogCache.Remove("Category-7")
			catalogCache.RemoveRegion("BeveragesRegion")
			catalogCache.RemoveRegion("ProduceRegion")

			Console.ReadLine()
		End Sub
	End Class
End Namespace
