﻿Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.Data.Caching

Imports NorthwindCacheDemo.DTO

Namespace VelocityClientConsole
	Friend Class CatalogTagSample
		Shared Sub Main(ByVal args() As String)
			' Create the catalog cache object
			Dim factory As New CacheFactory()
			Dim catalogCache As Cache = factory.GetCache("catalog")

			' Create a category region with eviction disabled
			catalogCache.CreateRegion("BeveragesRegion", False)
			catalogCache.CreateRegion("ProduceRegion", False)

			Dim topSeller As New Tag("TopSeller")

			' Build catalog
			catalogCache.Put("Category-1", New Category() With {.Name = "Beverages"})
			catalogCache.Put("Category-7", New Category() With {.Name = "Produce"})
			catalogCache.Put("BeveragesRegion", "Product-1", New Product() With {.Name = "Chai"})
			catalogCache.Put("BeveragesRegion", "Product-43", New Product() With {.Name = "Coffee"}, New Tag() { topSeller })
			catalogCache.Put("ProduceRegion", "Product-7", New Product() With {.Name = "Pears"})
			catalogCache.Put("ProduceRegion", "Product-51", New Product() With {.Name = "Apples"})

			Dim products As IList(Of KeyValuePair(Of String, Object)) = catalogCache.GetByTag("BeveragesRegion", topSeller)

			Dim p As Product = Nothing
			For Each kvp As KeyValuePair(Of String, Object) In products
				p = CType(kvp.Value, Product)
				Console.WriteLine(p.Name)
			Next kvp

			catalogCache.Remove("Category-1")
			catalogCache.Remove("Category-7")
			catalogCache.RemoveRegion("BeveragesRegion")
			catalogCache.RemoveRegion("ProduceRegion")

			Console.ReadLine()
		End Sub
	End Class
End Namespace
