﻿Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.Data.Caching

Imports NorthwindCacheDemo.DTO

Namespace VelocityClientConsole
	Friend Class ReportSample
		Shared Sub Main(ByVal args() As String)
			' Create catalog cache object
			Dim factory As New CacheFactory()
			Dim catalogCache As Cache = factory.GetCache("catalog")
			Dim reportCache As Cache = factory.GetCache("reports")

			' Build catalog
			catalogCache.Put("Category-1", New Category() With {.Name = "Beverages"})
			catalogCache.Put("Category-7", New Category() With {.Name = "Produce"})
			catalogCache.Put("Product-1", New Product() With {.Name = "Chai"})
			catalogCache.Put("Product-43", New Product() With {.Name = "Coffee"})
			catalogCache.Put("Product-7", New Product() With {.Name = "Pears"})
			catalogCache.Put("Product-51", New Product() With {.Name = "Apples"})

			' Create category lists
			Dim beverageIDs As IList(Of String) = New List(Of String)()
			beverageIDs.Add("Product-1")
			beverageIDs.Add("Product-43")
			catalogCache.Put("ProductList-1", beverageIDs)

			Dim produceIDs As IList(Of String) = New List(Of String)()
			produceIDs.Add("Product-7")
			produceIDs.Add("Product-51")
			catalogCache.Put("ProductList-7", produceIDs)

			' Create top selling product id list, and add to reports cache
			Dim topSellerIDs As IList(Of String) = New List(Of String)()
			topSellerIDs.Add("Product-43")
			topSellerIDs.Add("Product-51")

			reportCache.Put("TopSellingList", topSellerIDs)

			' Get the top selling product id list from the reports cache
			topSellerIDs = CType(reportCache.Get("TopSellingList"), List(Of String))

			' Iterate through id list, and retrieve products from cache
			Dim p As Product = Nothing
			For Each id As String In topSellerIDs
				p = CType(catalogCache.Get(id), Product)
				Console.WriteLine(p.Name)
			Next id

			reportCache.Remove("TopSellingList")
			catalogCache.Remove("ProductList-1")
			catalogCache.Remove("ProductList-7")
			catalogCache.Remove("Category-1")
			catalogCache.Remove("Category-7")
			catalogCache.Remove("Product-1")
			catalogCache.Remove("Product-43")
			catalogCache.Remove("Product-7")
			catalogCache.Remove("Product-51")

			Console.ReadLine()
		End Sub
	End Class
End Namespace
