﻿Imports Microsoft.VisualBasic
Imports System
Imports System.Data.Caching

Imports NorthwindCacheDemo.DTO

Namespace VelocityClientConsole
	Friend Class SessionSample
		Shared Sub Main(ByVal args() As String)
			' Create catalog cache object
			Dim factory As New CacheFactory()
			Dim sessionCache As Cache = factory.GetCache("session")

			Dim chai As New Product() With {.ProductID = 1, .Name = "Chai", .UnitPrice = 18.00D}
			Dim coffee As New Product() With {.ProductID = 43, .Name = "Coffee", .UnitPrice = 46.00D}
			Dim pears As New Product() With {.ProductID = 7, .Name = "Pears", .UnitPrice = 30.00D}
			Dim apples As New Product() With {.ProductID = 51, .Name = "Apples", .UnitPrice = 53.00D}

			' Create cart 1 with chai and apples
			Dim cart1 As New ShoppingCart()
			cart1(chai.ProductID) = New ShoppingCartItem() With {.ProductID = chai.ProductID, .UnitPrice = chai.UnitPrice, .Quantity = 1}

			cart1(apples.ProductID) = New ShoppingCartItem() With {.ProductID = apples.ProductID, .UnitPrice = apples.UnitPrice, .Quantity = 2}

			' Create cart 2 with pears and coffee
			Dim cart2 As New ShoppingCart()
			cart2(pears.ProductID) = New ShoppingCartItem() With {.ProductID = pears.ProductID, .UnitPrice = pears.UnitPrice, .Quantity = 4}

			cart2(coffee.ProductID) = New ShoppingCartItem() With {.ProductID = coffee.ProductID, .UnitPrice = coffee.UnitPrice, .Quantity = 3}

			' Add carts to cache
			sessionCache.Put("ShoppingCart-1", cart1)
			sessionCache.Put("ShoppingCart-2", cart2)

			' Get cart 1 from the cache
			cart1 = CType(sessionCache.Get("ShoppingCart-1"), ShoppingCart)

			' Iterate through cart items
			For Each item As ShoppingCartItem In cart1
				Console.WriteLine("ProductID: {0}, Unit Price {1}, Quantity: {2}", item.ProductID, item.UnitPrice, item.Quantity)
			Next item

			Console.WriteLine("Cart Total: {0}", cart1.Total)

			sessionCache.Remove("ShoppingCart-1")
			sessionCache.Remove("ShoppingCart-2")

			Console.ReadLine()
		End Sub
	End Class
End Namespace
